#include <queue>
#include <bitset>

namespace Reference
{
// Dumme und langsame Lösung, die aber offensichtlich korrekt ist.
int numMovesToSolve(const Level& level)
{
	struct State
	{
		uint8_t playerX[3];
		uint8_t playerY[3];
		uint16_t numMoves;
		
		inline size_t getPositionHash() const
		{
			size_t hash = playerX[0] - 1;
			hash += 14 * (playerY[0] - 1);
			hash += 14 * 14 * (playerX[1] - 1);
			hash += 14 * 14 * 14 * (playerY[1] - 1);
			hash += 14 * 14 * 14 * 14 * (playerX[2] - 1);
			hash += 14 * 14 * 14 * 14 * 14 * (playerY[2] - 1);
			return hash;
		}
	};
	
	bool isFree[16][16];
	
	State startState = { { 0, 0, 0 }, { 0, 0, 0 }, 0 };
	State goalState = startState;
	
	for (int x = 0; x < 16; ++x)
	{
		for (int y = 0; y < 16; ++y)
		{
			if (level[x][y] == '#') isFree[x][y] = false;
			else
			{
				isFree[x][y] = true;
				switch (level[x][y])
				{
					case 'r': startState.playerX[0] = x, startState.playerY[0] = y; break;
					case 'g': startState.playerX[1] = x, startState.playerY[1] = y; break;
					case 'b': startState.playerX[2] = x, startState.playerY[2] = y; break;
					case 'R': goalState.playerX[0] = x, goalState.playerY[0] = y; break;
					case 'G': goalState.playerX[1] = x, goalState.playerY[1] = y; break;
					case 'B': goalState.playerX[2] = x, goalState.playerY[2] = y; break;
				}
			}
		}
	}
	
	const size_t goalStatePositionHash = goalState.getPositionHash();
	
	std::queue<State> states;
	std::bitset<14 * 14 * 14 * 14 * 14 * 14> stateSeen;
	
	states.push(startState);
	stateSeen[startState.getPositionHash()] = true;
	
	while (!states.empty())
	{
		const State& state = states.front();
		
		for (int i = 0; i < 3; ++i)
			isFree[state.playerX[i]][state.playerY[i]] = false;
		
		for (int i = 0; i < 3; ++i)
		{
			int posX = state.playerX[i];
			int posY = state.playerY[i];
			
			// Nach links bewegen.
			while (isFree[posX - 1][posY]) --posX;
			if (posX != state.playerX[i])
			{
				State newState = state;
				newState.playerX[i] = posX;
				++newState.numMoves;
				const size_t newStatePositionHash = newState.getPositionHash();
				if (!stateSeen[newStatePositionHash])
				{
					if (newStatePositionHash == goalStatePositionHash) return newState.numMoves;
					states.push(newState);
					stateSeen[newStatePositionHash] = true;
				}
			}
			
			// Nach rechts bewegen.
			posX = state.playerX[i];
			while (isFree[posX + 1][posY]) ++posX;
			if (posX != state.playerX[i])
			{
				State newState = state;
				newState.playerX[i] = posX;
				++newState.numMoves;
				const size_t newStatePositionHash = newState.getPositionHash();
				if (!stateSeen[newStatePositionHash])
				{
					if (newStatePositionHash == goalStatePositionHash) return newState.numMoves;
					states.push(newState);
					stateSeen[newStatePositionHash] = true;
				}
			}
			
			// Nach oben bewegen.
			posX = state.playerX[i];
			while (isFree[posX][posY - 1]) --posY;
			if (posY != state.playerY[i])
			{
				State newState = state;
				newState.playerY[i] = posY;
				++newState.numMoves;
				const size_t newStatePositionHash = newState.getPositionHash();
				if (!stateSeen[newStatePositionHash])
				{
					if (newStatePositionHash == goalStatePositionHash) return newState.numMoves;
					states.push(newState);
					stateSeen[newStatePositionHash] = true;
				}
			}
			
			// Nach unten bewegen.
			posY = state.playerY[i];
			while (isFree[posX][posY + 1]) ++posY;
			if (posY != state.playerY[i])
			{
				State newState = state;
				newState.playerY[i] = posY;
				++newState.numMoves;
				const size_t newStatePositionHash = newState.getPositionHash();
				if (!stateSeen[newStatePositionHash])
				{
					if (newStatePositionHash == goalStatePositionHash) return newState.numMoves;
					states.push(newState);
					stateSeen[newStatePositionHash] = true;
				}
			}
		}
		
		for (int i = 0; i < 3; ++i)
			isFree[state.playerX[i]][state.playerY[i]] = true;
		
		states.pop();
	}
	
	return -1;
}
}