#ifndef STOPWATCH_H
#define STOPWATCH_H

#include <Windows.h>

class Stopwatch
{
public:
	Stopwatch()
	{
		uint64_t freq;
		QueryPerformanceFrequency(reinterpret_cast<LARGE_INTEGER*>(&freq));
		conv = 1.0 / freq;
		reset();
	}
	
	double operator ()() const
	{
		uint64_t t;
		QueryPerformanceCounter(reinterpret_cast<LARGE_INTEGER*>(&t));
		return conv * (t - t0);
	}
	
	void reset()
	{
		QueryPerformanceCounter(reinterpret_cast<LARGE_INTEGER*>(&t0));
	}
	
private:
	double conv;
	uint64_t t0;
};

#endif // STOPWATCH_H